Fapi_GetPlatformCertificates
Feature API

## Functions

TSS2_RC | Fapi_GetPlatformCertificates (FAPI_CONTEXT *context, uint8_t **certificates, size_t *certificatesSize)
TSS2_RC | Fapi_GetPlatformCertificates_Async (FAPI_CONTEXT *context)
TSS2_RC | Fapi_GetPlatformCertificates_Finish (FAPI_CONTEXT *context, uint8_t **certificates, size_t *certificatesSize)

## Detailed Description

FAPI functions to invoke GetPlatformCertificates either as one-call or in an asynchronous manner.

## Function Documentation

## Fapi_GetPlatformCertificates()

TSS2_RC Fapi_GetPlatformCertificates | ( | FAPI_CONTEXT * | context,
|  | uint8_t ** | certificates,
|  | size_t * | certificatesSize )

One-Call function for Fapi_GetPlatformCertificates

Platform certificates for TPM 2.0 can consist not only of a single certificate but a series of so-called delta certificates. This function returns the set of Platform certificates concatenated in a continuous buffer.

Parameters

  [in,out] | context | The FAPI_CONTEXT
  [out] | certificates | The platform certificates
  [out] | certificatesSize | The size of the buffer with the certificates. May be NULL

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context or certificates is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_NO_TPM | if FAPI was initialized in no-TPM-mode via its config file.
  TSS2_FAPI_RC_NO_CERT | if an error did occur during certificate downloading.
  TSS2_FAPI_RC_TRY_AGAIN | if an I/O operation is not finished yet and this function needs to be called again.
  TSS2_FAPI_RC_AUTHORIZATION_UNKNOWN | if a required authorization callback is not set.
  TSS2_FAPI_RC_AUTHORIZATION_FAILED | if the authorization attempt fails.
  TSS2_FAPI_RC_GENERAL_FAILURE | if an internal error occurred.
  TSS2_FAPI_RC_POLICY_UNKNOWN | if policy search for a certain policy digest was not successful.
  TSS2_ESYS_RC_* | possible error codes of ESAPI.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if a key was not found.
  TSS2_FAPI_RC_BAD_PATH | if the path is used in inappropriate context or contains illegal characters.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.

## Fapi_GetPlatformCertificates_Async()

TSS2_RC Fapi_GetPlatformCertificates_Async | ( | FAPI_CONTEXT * | context | ) |

Asynchronous function for Fapi_GetPlatformCertificates

Platform certificates for TPM 2.0 can consist not only of a single certificate but a series of so-called delta certificates. This function returns the set of Platform certificates concatenated in a continuous buffer.

Call Fapi_GetPlatformCertificates_Finish to finish the execution of this command.

Parameters

  [in,out] | context | The FAPI_CONTEXT

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_NO_TPM | if FAPI was initialized in no-TPM-mode via its config file.

## Fapi_GetPlatformCertificates_Finish()

TSS2_RC Fapi_GetPlatformCertificates_Finish | ( | FAPI_CONTEXT * | context,
|  | uint8_t ** | certificates,
|  | size_t * | certificatesSize )

Asynchronous finish function for Fapi_GetPlatformCertificates

This function should be called after a previous Fapi_GetPlatformCertificates_Async.

Parameters

  [in,out] | context | The FAPI_CONTEXT
  [out] | certificates | The platform certificates
  [out] | certificatesSize | The size of the buffer with the certificates. May be NULL

Return values

  TSS2_RC_SUCCESS | if the function call was a success.
  TSS2_FAPI_RC_BAD_REFERENCE | if context or certificates is NULL.
  TSS2_FAPI_RC_BAD_CONTEXT | if context corruption is detected.
  TSS2_FAPI_RC_BAD_SEQUENCE | if the context has an asynchronous operation already pending.
  TSS2_FAPI_RC_IO_ERROR | if the data cannot be saved.
  TSS2_FAPI_RC_MEMORY | if the FAPI cannot allocate enough memory for internal operations or return parameters.
  TSS2_FAPI_RC_TRY_AGAIN | if the asynchronous operation is not yet complete. Call this function again later.
  TSS2_FAPI_RC_NO_CERT | if an error did occur during certificate downloading.
  TSS2_FAPI_RC_AUTHORIZATION_UNKNOWN | if a required authorization callback is not set.
  TSS2_FAPI_RC_AUTHORIZATION_FAILED | if the authorization attempt fails.
  TSS2_FAPI_RC_GENERAL_FAILURE | if an internal error occurred.
  TSS2_FAPI_RC_POLICY_UNKNOWN | if policy search for a certain policy digest was not successful.
  TSS2_ESYS_RC_* | possible error codes of ESAPI.
  TSS2_FAPI_RC_NOT_PROVISIONED | FAPI was not provisioned.
  TSS2_FAPI_RC_KEY_NOT_FOUND | if a key was not found.
  TSS2_FAPI_RC_BAD_PATH | if the path is used in inappropriate context or contains illegal characters.
  TSS2_FAPI_RC_BAD_VALUE | if an invalid value was passed into the function.
  TSS2_FAPI_RC_PATH_NOT_FOUND | if a FAPI object path was not found during authorization.